// eslint-disable-next-line @typescript-eslint/no-var-requires
const path = require('path');

module.exports = {
	root: true,
	env: {
		node: true,
	},
	plugins: ['@typescript-eslint', 'import', 'prettier', 'simple-import-sort'],
	extends: ['airbnb-typescript/base', 'prettier', 'plugin:@typescript-eslint/recommended', 'plugin:import/typescript'],
	parserOptions: { project: path.resolve(__dirname, 'tsconfig.eslint.json') },
    ignorePatterns: [
		'*.js',
		'*.d.ts'
	],
	rules: {
		'simple-import-sort/imports': 'error',
		'simple-import-sort/exports': 'error',
		'prettier/prettier': [
			'warn',
			{
				semi: true,
				bracketSpacing: true,
				singleQuote: true,
				tabWidth: 4,
				trailingComma: 'es5',
				useTabs: true,
				printWidth: 150,
			},
		],
		'@typescript-eslint/explicit-function-return-type': 'off',
		'@typescript-eslint/naming-convention': 'off',
		'@typescript-eslint/no-redeclare': 'off',
		'@typescript-eslint/no-misused-promises': 'off',
		'@typescript-eslint/no-extraneous-class': 'off',
		'@typescript-eslint/no-base-to-string': 'off',
		'@typescript-eslint/no-empty-interface': 'off',
		'@typescript-eslint/restrict-template-expressions': 'off',
		'@typescript-eslint/ban-ts-comment': 'off',
		'@typescript-eslint/no-unused-vars': [
			'warn',
			{
				argsIgnorePattern: '^_',
			},
		],
		'import/extensions': 0,
	},
};
