import { RouteInfo } from '@nestjs/common/interfaces';
import { Levels } from './winston/transports/slack.transport.types';
export declare enum LOG_LEVEL {
    Emergency = "emergency",
    Fatal = "fatal",
    Error = "error",
    Warn = "warn",
    Info = "info",
    Debug = "debug"
}
export type LoggerModuleOptions = {
    appName: string;
    nodeEnv: string;
    slack: {
        enabled: boolean;
        levels?: Levels;
        webhook?: {
            url: string;
        };
    };
    morgan?: {
        exclude: (string | RouteInfo)[];
    };
};
export declare const LoggerBaseKey: unique symbol;
export declare const LoggerKey: unique symbol;
export type Logger = {
    log(level: LOG_LEVEL, message: string | Error, context: string, data?: unknown): void;
    debug(message: string, context: string, data?: unknown): void;
    info(message: string, context: string, data?: unknown): void;
    warn(message: string | Error, context: string, data?: unknown): void;
    error(message: string | Error, context: string, data?: unknown): void;
    fatal(message: string | Error, context: string, data?: unknown): void;
    emergency(message: string | Error, context: string, data?: unknown): void;
};
